#include "..\00_hal\glcd_drvs6bx_hal.h"

#define NOP			__asm	nop
#define LCD_DI						BIT3
#define LCD_WR						BIT1
#define LCD_RD						BIT2
#define LCD_CS1						BIT0
#define LCD_CS2						BIT11
#define LCD_BACK					BIT4
#define LCD_LVIN					BIT5
#define LCD_LVCLK					BIT6
#define LCD_LVSTR					BIT7

#define LCD_WR_ON()					LCD_DATA_WRON()
#define LCD_WR_OFF()				LCD_DATA_WROFF()
#define LCD_RD_ON()					LCD_DATA_RDON()
#define LCD_RD_OFF()				LCD_DATA_RDOFF()

#define LCD_RE_ON()					LCD_DATA_REON()	
#define LCD_RE_OFF()				LCD_DATA_REOFF()
#define LCD_CS1_ON()				LCD_DATA_CS1ON()
#define LCD_CS1_OFF()				LCD_DATA_CS1OFF()
#define LCD_CS2_ON()				
#define LCD_CS2_OFF()				

#define LCD_ENABLE()				LCD_DATA_CS1OFF()
#define LCD_DISABLE()				LCD_DATA_CS1ON()
#define LCD_BACK_ON()				
#define LCD_BACK_OFF()				

#define LcdDataOut					OutData
#define LcdDataIn()					

#define LcdBackLight(Flag)				((Flag)?SbiShiftData(LCD_BACK):CbiShiftData(LCD_BACK))


#define LCD_CMD_DELAY   10


#define GLCD_NUM_CONTROLLERS	((GLCD_XPIXELS+GLCD_CONTROLLER_XPIXELS-1)/GLCD_CONTROLLER_XPIXELS)


#define GLCD_SET_CSR		0x46	
#define GLCD_WRITE_DISP		0x42
#define GLCD_ON_CTRL		0x3E
#define GLCD_ON_DISPLAY		0x01

#define GLCD_START_LINE		0xC0

#define GLCD_SET_PAGE		0xB8
#define GLCD_SET_Y_ADDR		0x40

#define GLCD_STATUS_BUSY	0x80
#define GLCD_STATUS_ONOFF	0x20
#define GLCD_STATUS_RESET	0x10

#define GLCD_XPIXELS			240
#define GLCD_YPIXELS			160

#define GLCD_TEXT_LINES           8 
#define GLCD_TEXT_LINE_LENGTH    500

#define LCD_CMD_DELAY   10

#define TXT_HOME_ADDR	0x0000	
#define GR_HOME_ADDR	0x0000	
#define COLUMN_LENGTH		30	

//unsigned char m_LcdTempBuf[30][160] = {0,};
void CLcd_Fill(unsigned int Ch);
void Lcd_Delay(unsigned int Cnt);

void Lcd_Data(unsigned int Ch)
{
//	Lcd_Delay(LCD_CMD_DELAY);
	
 	LCD_ENABLE();
 		
	LCD_RE_ON();	

	LcdDataOut(Ch);	

	LCD_WR_OFF();	
	LCD_WR_ON();	

 	LCD_DISABLE();
}

void Lcd_Cmd(unsigned char Cmd)
{
//	Lcd_Delay(LCD_CMD_DELAY);

	LCD_ENABLE();

	LCD_RE_OFF(); 	

	//LcdDataOut(Cmd);
	OutControl(Cmd);	
 
 	
	LCD_WR_OFF();
	LCD_WR_ON();
	
	LCD_DISABLE();
}

void Lcd_Data2Byte(unsigned int iData)	
{ 

}


void Lcd_Delay(unsigned int Cnt)
{
	unsigned int i;
	unsigned int j;
	
	for(j=0; j<Cnt; j++){
		for(i=0; i<1; i++);
	}
}


#define SCROLL		0x44
#define SYSTEM_SET	0x40
#define HDOT_SCR	0x5A
#define OVLAY		0x5B
#define CSRW		0x46
#define CSRFORM		0x5D
#define DISP_ON		0x59
#define CSRDIR		0x4C

#define CHAR_PIXEL_X	8
#define LCD_PIXELCOLS	240
#define LCD_PIXELROWS	160

#define	RED		0xF800
#define GREEN	0x07E0
#define BLUE	0x001F
#define BLACK	0x0000
#define WHITE	0xFFFF

void CLcd_Init(void)
{
	clcd_init_hal();
  	Delay(100);
 	Lcd_Cmd(0x50);	//set display off
	Lcd_Cmd(0x2c);	//set standby mode off
	Delay(100);
	
	Lcd_Cmd(0x02);	//set osc mode
	Lcd_Cmd(0x01);
	Lcd_Cmd(0x20);	//set dc-dc
	Lcd_Cmd(0x01);
    
	Lcd_Cmd(0x10);	//set driver output mode set
	Lcd_Cmd(0x03);
    
//	Lcd_Cmd(0x22);	//set bias
//	Lcd_Cmd(0x33);
    

    
    Lcd_Cmd(0x26);	//set dc-dc & amp on off	
	Lcd_Cmd(0x01);
	Lcd_Cmd(0x26);
	Lcd_Cmd(0x09);
	Lcd_Cmd(0x26);
	Lcd_Cmd(0x0b);
	Lcd_Cmd(0x26);
	Lcd_Cmd(0x0f);    
    
    
	Lcd_Cmd(0x28);	//set temperature
	Lcd_Cmd(0x00);
	Lcd_Cmd(0x30);	//set addressing mode
    Lcd_Cmd(0x00);

  	Lcd_Cmd(0x42);	//set x address
	Lcd_Cmd(4);
	Lcd_Cmd(127+4);    

	Lcd_Cmd(0x43);  //set y address
	Lcd_Cmd(0x00);
	Lcd_Cmd(127);
    
	Lcd_Cmd(0x34);	//set nblock
   	Lcd_Cmd(0x8d);    
    
    Lcd_Cmd(0x2a);	//set contrast
	Lcd_Cmd(0xc5);    
    
//	Lcd_Cmd(0x53);	//set nblock
//   	Lcd_Cmd(0x03);    
    
	Lcd_Cmd(0x51);	//set display on

    
	CLcd_Fill(0x0000);
}

void GlcdSetAddress(UINT X, UINT Y)
{

}

//Back ground 
void CLcd_Fill(unsigned int Ch)
{
	INT i,j;
	Lcd_Cmd(0x42);	//set x address
	Lcd_Cmd(4);
	Lcd_Cmd(127+5);
    
	Lcd_Cmd(0x43);  //set y address
	Lcd_Cmd(0x00);
	Lcd_Cmd(127);

	for(i=0;i<128;i++)
	{
		for(j=0;j<128;j++)
		{
			Lcd_Data(Ch);
            //Delay(10);
 		}
	}
}

void GlcdClear(void)
{

}

void GlcdDot(unsigned int X, unsigned int Y, UINT Flag)
{ 
  /*
	INT i,j;
	Lcd_Cmd(0x42);	//set x address
	Lcd_Cmd(127-Y+4);
	Lcd_Cmd(127-Y+4+1);
    
	Lcd_Cmd(0x43);  //set y address
	Lcd_Cmd(X);
	Lcd_Cmd(X+1);

    Lcd_Data(Flag);*/

  	INT i,j;
	Lcd_Cmd(0x42);	//set x address
	Lcd_Cmd(Y+4);
	Lcd_Cmd(127);
    
	Lcd_Cmd(0x43);  //set y address
	Lcd_Cmd(X);
	Lcd_Cmd(127);

    Lcd_Data(Flag);

}






